#!/bin/sh

VERSION="listchange version 1.0"

max_argument=1
arg="--changelog"
#prefix1="mirror.yandex.ru/altlinux/Sisyphus/i586/RPMS.classic/"
#prefix2="mirror.yandex.ru/altlinux/Sisyphus/noarch/RPMS.classic/"
prefix1="mirror.yandex.ru/altlinux/Sisyphus/files/i586/RPMS/"
prefix2="mirror.yandex.ru/altlinux/Sisyphus/files/noarch/RPMS/"


usage(){
  echo "Usage: $0 --help | --version | [ --lastchange | --changelog ] packet
Print last change for rpm package packet

OPTIONS:
	-h, --help	print this message and exit
	-v, --version	print version information and exit
	--lastchange	print last change from changelog for packet
	--changelog	print full changelog for package
" >&2
  return 0
}

check_packet(){
  if [ -z "$1" ]; then
    echo "Null argument" >&2
    return 1
  fi
  prefix="$1"
  fpacket=`rsync rsync://$prefix | awk '{ print $5 }' | grep -e "^$packet-[0-9]" `
  if [ -z "$fpacket" ]; then
    return 1
  fi
  rpmquery -p $arg ftp://$prefix$fpacket
  echo "Executed: rpmquery -p $arg ftp://$prefix$fpacket" >&2
  return 0
}

case "$1" in
    --help|-h)
	usage
	exit 0
	;;
    --version|-v)
	echo "$VERSION"
	exit 0
	;;
    --changelog|--lastchange|-ql)
	arg="$1"
	shift
	;;
	*)
	arg="$*"
	shift
	;;
esac

if [ -z "$1" ]; then
    usage
    exit 1
fi

if [ "$#" -gt $max_argument   ]; then
    usage
    exit 1
fi

packet="$1"

echo "arg=$arg" >&2
check_packet "$prefix1" || check_packet "$prefix2" || echo "Not found $packet" >&2